package com.example.vr1;
import android.content.Intent;
import android.os.Build;
//import android.support.annotation.RequiresApi;
import android.os.Environment;
import android.support.v7.app.AppCompatActivity;
import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;


import com.instacart.library.truetime.TrueTime;
import com.instacart.library.truetime.TrueTimeRx;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.lang.Math;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Random;
import java.util.concurrent.TimeUnit;

import io.reactivex.schedulers.Schedulers;

/* Flash the screen between red and green each second */
public class MainActivity extends Activity {
    final static int INTERVAL = 1000; // 1000=1sec
    private static ImageView myView1 = null;
    private static ImageView myView2 = null;
    Integer[] target_colors = new Integer[]{2, 1, 2, 2, 2, 1, 1, 2, 1, 0, 2, 0, 0, 1, 1, 2, 1, 1, 1, 0, 0, 0, 0, 0, 2, 2, 1, 2, 0, 0, 1, 2, 2, 2, 0, 2, 2, 0, 1, 1, 2, 0, 1, 0, 0, 0, 2, 1, 1, 1, 2, 0, 1, 0, 0, 1, 2, 2, 0, 1};
    Integer[] target_colors_red = new Integer[]{12,19,21,23,34,37,45,53,58,43};
    Integer[] target_colors_green = new Integer[]{1,5,8,14,26,30,38,47,52,55};
    Integer[] target_colors_blue = new Integer[]{3,7,25,31,32,35,40,46,50,56};


    boolean whichColor = true;
    Random rgen = new Random();  // Random number generator
    int i;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_main);


        //List<Integer> li_num = Arrays.asList(target_colors);
        //Collections.shuffle(li_num);
        Intent intent = getIntent();
        final int time = intent.getIntExtra("message",100);
        //target_colors  = (Integer[])li_num.toArray();
        Log.d("array",Arrays.toString(target_colors));

        new Thread(new Runnable() {
            public void run() {
                try {
                    TrueTimeRx.build()
                            .initializeRx("time.google.com")
                            .subscribeOn(Schedulers.io())
                            .subscribe(date -> {
                                Log.v("macha", "TrueTime was initialized and we have a time: " + date);
                            }, throwable -> {
                                throwable.printStackTrace();
                            });
                    Date noReallyThisIsTheTrueDateAndTime = TrueTimeRx.now();
                    //Log.d("macha", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                } catch (Exception e) {
                    e.printStackTrace();
                }
                for (int i = 0; i < 60; ++i) {

                    int target = target_colors[i];
                    int target_color = 0;
                    if (target == 0) {
                        target_color = Color.RED;
                    }

                    if (target == 1) {

                        target_color = Color.GREEN;
                    }

                    if (target == 2) {

                        target_color = Color.BLUE;
                    }

                    myView1 = (ImageView) findViewById(R.id.imageView);
                    myView1.setBackgroundColor(target_color);// set initial colour
                    myView2 = (ImageView) findViewById(R.id.imageView2);
                    myView2.setBackgroundColor(target_color);
                    try {
                        Thread.sleep(INTERVAL * 2);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    myView1.setBackgroundColor(Color.BLACK);// set initial colour
                    myView2.setBackgroundColor(Color.BLACK);

                    try {
                        Thread.sleep(3000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    //int target_flash_1 = (int) (Math.random() * ((2 - 0) + 1)) + 0;
                    int target_flash_1_color = 0;
                    int target_flash_2_color = 0;
                    //int target_flash_2 = (target_flash_1 + 1) % 3;
                    int x = 0;
                    if (target==0) {
                        if(Arrays.asList(target_colors_red).indexOf(i)!=-1){
                            if (i == 12 ||i == 21 || i == 23 || i == 45 || i == 43) {
                                target_flash_1_color = Color.RED;



                                Date noReallyThisIsTheTrueDateAndTime = TrueTimeRx.now();
                                Log.d("macha", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                try {
                                    File path = Environment.getExternalStoragePublicDirectory(
                                            Environment.DIRECTORY_DOWNLOADS);
                                    File myFile = new File(path, "mytextfile.txt");
                                    FileOutputStream fOut = new FileOutputStream(myFile,true);
                                    OutputStreamWriter myOutWriter = new OutputStreamWriter(fOut);
                                    myOutWriter.append(String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()) +"L"+ "\n");
                                    Log.d("File", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                    myOutWriter.close();
                                    fOut.close();
                                }
                                catch (java.io.IOException e) {
                                    e.printStackTrace();
                                }

                                Log.d("Time", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));








                                x = (int) (Math.random() * ((1 - 0) + 1)) + 0;
                                Log.d("rand_number", String.valueOf(x));
                                if (x == 0)
                                    target_flash_2_color = Color.GREEN;
                                else
                                    target_flash_2_color = Color.BLUE;
                            }
                            else{
                                target_flash_2_color = Color.RED;




                                Date noReallyThisIsTheTrueDateAndTime = TrueTimeRx.now();
                                Log.d("macha", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                try {
                                    File path = Environment.getExternalStoragePublicDirectory(
                                            Environment.DIRECTORY_DOWNLOADS);
                                    File myFile = new File(path, "mytextfile.txt");
                                    FileOutputStream fOut = new FileOutputStream(myFile,true);
                                    OutputStreamWriter myOutWriter = new OutputStreamWriter(fOut);
                                    myOutWriter.append(String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()) + "R"+"\n");
                                    Log.d("File", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                    myOutWriter.close();
                                    fOut.close();
                                }
                                catch (java.io.IOException e) {
                                    e.printStackTrace();
                                }

                                Log.d("Time", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));




                                x = (int) (Math.random() * ((1 - 0) + 1)) + 0;
                                Log.d("rand_number", String.valueOf(x));
                                if (x == 0)
                                    target_flash_1_color = Color.GREEN;
                                else
                                    target_flash_1_color = Color.BLUE;
                            }
                        }


                        else{
                            x =  (int) (Math.random() * ((1 - 0) + 1)) + 0;
                            if(x==0) {
                                target_flash_1_color = Color.GREEN;
                                target_flash_2_color = Color.BLUE;
                            }
                            else {
                                target_flash_1_color = Color.BLUE;
                                target_flash_2_color = Color.GREEN;
                            }
                        }
                    }
                    if (target==1) {
                        if(Arrays.asList(target_colors_green).indexOf(i)!=-1){
                            if (i == 5 || i == 14 || i == 26 || i == 30 || i == 52) {
                                target_flash_1_color = Color.GREEN;


                                Date noReallyThisIsTheTrueDateAndTime = TrueTimeRx.now();
                                Log.d("macha", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                try {
                                    File path = Environment.getExternalStoragePublicDirectory(
                                            Environment.DIRECTORY_DOWNLOADS);
                                    File myFile = new File(path, "mytextfile.txt");
                                    FileOutputStream fOut = new FileOutputStream(myFile,true);
                                    OutputStreamWriter myOutWriter = new OutputStreamWriter(fOut);
                                    myOutWriter.append(String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()) +"L"+ "\n");
                                    Log.d("File", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                    myOutWriter.close();
                                    fOut.close();
                                }
                                catch (java.io.IOException e) {
                                    e.printStackTrace();
                                }

                                Log.d("Time", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));




                                x = (int) (Math.random() * ((1 - 0) + 1)) + 0;
                                if (x == 0)
                                    target_flash_2_color = Color.RED;
                                else
                                    target_flash_2_color = Color.BLUE;
                            }
                            else{
                                target_flash_2_color = Color.GREEN;

                                Date noReallyThisIsTheTrueDateAndTime = TrueTimeRx.now();
                                Log.d("macha", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                try {
                                    File path = Environment.getExternalStoragePublicDirectory(
                                            Environment.DIRECTORY_DOWNLOADS);
                                    File myFile = new File(path, "mytextfile.txt");
                                    FileOutputStream fOut = new FileOutputStream(myFile,true);
                                    OutputStreamWriter myOutWriter = new OutputStreamWriter(fOut);
                                    myOutWriter.append(String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()) +"R"+ "\n");
                                    Log.d("File", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                    myOutWriter.close();
                                    fOut.close();
                                }
                                catch (java.io.IOException e) {
                                    e.printStackTrace();
                                }

                                Log.d("Time", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                x = (int) (Math.random() * ((1 - 0) + 1)) + 0;
                                if (x == 0)
                                    target_flash_1_color = Color.BLUE;
                                else
                                    target_flash_1_color = Color.RED;
                            }
                        }


                        else{
                            x =  (int) (Math.random() * ((1 - 0) + 1)) + 0;
                            if(x==0) {
                                target_flash_1_color = Color.RED;
                                target_flash_2_color = Color.BLUE;
                            }
                            else {
                                target_flash_1_color = Color.BLUE;
                                target_flash_2_color = Color.RED;
                            }
                        }
                    }

                    if (target==2) {
                        if(Arrays.asList(target_colors_blue).indexOf(i)!=-1){
                            if (i == 3 || i == 7 || i == 25 || i == 35 || i == 56) {
                                target_flash_1_color = Color.BLUE;




                                Date noReallyThisIsTheTrueDateAndTime = TrueTimeRx.now();
                                Log.d("macha", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                try {
                                    File path = Environment.getExternalStoragePublicDirectory(
                                            Environment.DIRECTORY_DOWNLOADS);
                                    File myFile = new File(path, "mytextfile.txt");
                                    FileOutputStream fOut = new FileOutputStream(myFile,true);
                                    OutputStreamWriter myOutWriter = new OutputStreamWriter(fOut);
                                    myOutWriter.append(String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()) +"L" +"\n");
                                    Log.d("File", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                    myOutWriter.close();
                                    fOut.close();
                                }
                                catch (java.io.IOException e) {
                                    e.printStackTrace();
                                }

                                Log.d("Time", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                x = (int) (Math.random() * ((1 - 0) + 1)) + 0;
                                if (x == 0)
                                    target_flash_2_color = Color.RED;
                                else
                                    target_flash_2_color = Color.GREEN;
                            }
                            else{
                                target_flash_2_color = Color.BLUE;



                                Date noReallyThisIsTheTrueDateAndTime = TrueTimeRx.now();
                                Log.d("macha", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                try {
                                    File path = Environment.getExternalStoragePublicDirectory(
                                            Environment.DIRECTORY_DOWNLOADS);
                                    File myFile = new File(path, "mytextfile.txt");
                                    FileOutputStream fOut = new FileOutputStream(myFile,true);
                                    OutputStreamWriter myOutWriter = new OutputStreamWriter(fOut);
                                    myOutWriter.append(String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()) + "R"+"\n");
                                    Log.d("File", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                    myOutWriter.close();
                                    fOut.close();
                                }
                                catch (java.io.IOException e) {
                                    e.printStackTrace();
                                }

                                Log.d("Time", String.valueOf(noReallyThisIsTheTrueDateAndTime.getTime()));
                                x = (int) (Math.random() * ((1 - 0) + 1)) + 0;
                                if (x == 0)
                                    target_flash_1_color = Color.GREEN;
                                else
                                    target_flash_1_color = Color.RED;
                            }
                        }


                        else{
                            x =  (int) (Math.random() * ((1 - 0) + 1)) + 0;
                            if(x==0) {
                                target_flash_1_color = Color.RED;
                                target_flash_2_color = Color.GREEN;
                            }
                            else {
                                target_flash_1_color = Color.GREEN;
                                target_flash_2_color = Color.RED;

                            }
                        }
                    }

                    myView1.setBackgroundColor(target_flash_1_color);// set initial colour
                    myView2.setBackgroundColor(target_flash_2_color);

                    try {
                        Thread.sleep(time);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    myView1.setBackgroundColor(Color.BLACK);// set initial colour
                    myView2.setBackgroundColor(Color.BLACK);

                    try {
                        Thread.sleep(3000);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }

                }
            }
        }).start();

    }




}