package com.example.vr1;

import android.content.Intent;
import android.content.IntentFilter;
import android.os.CountDownTimer;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.instacart.library.truetime.TrueTime;

import java.io.IOException;
import java.util.Date;

public class Home extends AppCompatActivity {
    private EditText tb1 = null;
    private Button bt1= null;
    private TextView tv1 =null;


    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_home);


        tb1 = (EditText) findViewById(R.id.tb1);
        tv1 = (TextView) findViewById(R.id.tv1);
        bt1 = (Button) findViewById(R.id.bt1);
        bt1.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int time =  Integer.parseInt(tb1.getText().toString());


                Intent intent = new Intent(getApplicationContext(), MainActivity.class);
                intent.putExtra("message", time);
                new CountDownTimer(20000, 1000) {

                    public void onTick(long millisUntilFinished) {
                        tv1.setText("seconds remaining: " + millisUntilFinished / 1000);
                        //here you can have your logic to set text to edittext
                    }

                    public void onFinish() {
                        tv1.setText("done!");
                        startActivity(intent);
                    }

                }.start();


            }
        });
    }
}
